class RequestsClass {
    url: string
    constructor (url: string) {
        this.url = url;
    }
    
    async _post(url: string, data: any): Promise<any> {
        const request = await fetch(`${this.url}/${url}`, {
            method: 'POST',
            mode: 'cors',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(data),
        });
        return request.json();
    }

    async _get(url: string): Promise<any> {
        const request = await fetch(`${this.url}/${url}`);
        return request.json();
    }

    animations = {
        list: (): Promise<AnimationBase[]> => this._get("animations"),
        toggle: (name: string): Promise<void> => this._get(`toggle/${name}`)
    }
    
    active(): Promise<ActiveAnimations> {
        return this._get("active");
    }

}

export type AnimationBase = {
    id: number,
    name: string,
    priority: number,
    repeat: boolean
}

export type ActiveAnimations = {
    active_animations: string[],
    code: nubmer
}

export const Requests = new RequestsClass('http://aether:3000');
